/**! media-query-parser | Tom Golden <oss@tom.bio> (https://tom.bio) | @license MIT  */
import {
	matchCondition as r,
	matchFeature as t,
	matchQuery as e,
	matchQueryList as n
} from './ast/ast.js'
import {
	generateQueryList as o,
	generateQuery as i,
	generateCondition as s,
	generateFeature as a,
	generateValue as d
} from './generator/generator.js'
import {lexer as l} from './lexer/lexer.js'
import {isParserError as u} from './utils.js'
export const parseMediaQueryList = r => {
	const t = l(r)
	return u(t) ? t : n(t)
}
export const parseMediaQuery = r => {
	var t, n, o, i
	const s = l(r)
	if (u(s)) return s
	{
		const r = e(s)
		return r && r.i === s.length
			? r.n
			: {
					errid: 'INVALID_QUERY',
					start:
						null !== (n = null === (t = s.at(0)) || void 0 === t ? void 0 : t.start) && void 0 !== n
							? n
							: 0,
					end:
						null !== (i = null === (o = s.at(-1)) || void 0 === o ? void 0 : o.end) && void 0 !== i
							? i
							: 0
			  }
	}
}
export const parseMediaCondition = t => {
	var e, n, o, i
	const s = l(t)
	if (u(s)) return s
	{
		const t = r(s)
		return t && t.i === s.length
			? t.n
			: {
					errid: 'INVALID_CONDITION',
					start:
						null !== (n = null === (e = s.at(0)) || void 0 === e ? void 0 : e.start) && void 0 !== n
							? n
							: 0,
					end:
						null !== (i = null === (o = s.at(-1)) || void 0 === o ? void 0 : o.end) && void 0 !== i
							? i
							: 0
			  }
	}
}
export const parseMediaFeature = r => {
	var e, n, o, i
	const s = l(r)
	if (u(s)) return s
	{
		const r = t(s)
		return r && r.i === s.length
			? r.n
			: {
					errid: 'INVALID_FEATURE',
					start:
						null !== (n = null === (e = s.at(0)) || void 0 === e ? void 0 : e.start) && void 0 !== n
							? n
							: 0,
					end:
						null !== (i = null === (o = s.at(-1)) || void 0 === o ? void 0 : o.end) && void 0 !== i
							? i
							: 0
			  }
	}
}
export const stringify = r => {
	switch (r.n) {
		case 'query-list':
			return o(r)
		case 'query':
			return i(r)
		case 'condition':
			return s(r)
		case 'feature':
			return a(r)
		default:
			return d(r)
	}
}
export * from './utils.js'
